// ACM 2006
//   "Problem C. Customer support"
// Sergio A. Fjodorov, Timofey S. Chistyakov

//   :
//   N [MAX_Q [RandSeed [A [X]]]]
// A, X --    ai, xi ( random)

{$apptype console}

uses
  SysUtils;

const
  MAX_Q = 1000000;

var
  n: integer;
  i: integer;
  maxQ: integer;
  a, x, aa, xx: integer;


begin
  Assign(output, 'input.txt');
  Rewrite(output);

  n := StrToInt(ParamStr(1));

  if ParamCount > 1 then
    maxQ := StrToInt(ParamStr(2))
  else
    maxQ := MAX_Q;

  if ParamCount > 2 then
    RandSeed := StrToInt(ParamStr(3))
  else
    Randomize;

  if ParamCount > 3 then
    a := StrToInt(ParamStr(4))
  else
    a := -1;

  if ParamCount > 4 then
    x := StrToInt(ParamStr(5))
  else
    x := -1;

  WriteLn(n);
  for i := 1 to n do begin
    if a = -1 then
      aa := Random(2)
    else
      aa := a;
    if x = -1 then
      xx := Random(2)
    else
      xx := x;
    WriteLn(Random(maxQ) + 1, ' ', aa, ' ', xx);
  end;

  Close(output);
end.